/*
*       myhtb.c        Silviu Vladuti   <zyx@zyx.ro>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>


#include "mysql.h"
#include <time.h>

int streql(char *str1,char *str2);	

char dbhost[256];
char dbuser[256];
char dbpassword[256];
char database[256];

char devup[256];
char devdown[256];
char *intup;
char *intdown;

char uprootclass[256];
char downrootclass[256];
char *uprate , *downrate;

char *rdate , *fdate;

char mytime[25];
char mylogtime[50];
struct tm *data_curenta;
time_t  secunde;
		
MYSQL mysql;
MYSQL_RES *res;
MYSQL_ROW row;

struct qclients {
    int qid;
    int qip;
    int qname;
    int qcir;
    int qmir;

    struct qclients *qnext;
    } qstart, *q;



		    
int exiterr(int exitcode)
{
    fprintf( stderr, "%s\n", mysql_error(&mysql) );
    exit( exitcode );
}
	

int main() {
    
    time(&secunde);
    data_curenta = localtime(&secunde);

    sprintf(mytime,"%d%d%d%d%d",data_curenta->tm_mon+1,data_curenta->tm_mday,data_curenta->tm_year+1900,data_curenta->tm_hour,data_curenta->tm_min);
    sprintf(mylogtime,"%d-%d-%d %d:%d",data_curenta->tm_mon+1,data_curenta->tm_mday,data_curenta->tm_year+1900,data_curenta->tm_hour,data_curenta->tm_min);
    getconf();
    getdbset();
    updatedbd();    
    updatedbu();    
    checkserial();

return 0;					
}

int getconf()
{
        char buffer[100];       // a variable for the strings we read in
        FILE *inputfile;        // a pointer to the input file
        inputfile = fopen("/etc/myhtb.conf", "r");      // open myhtb.conf


        if(inputfile != NULL)
        {
                while (fgets(buffer, 100, inputfile))
                {
                        if (strstr (buffer, "db-host")) {
                        sscanf(buffer ,"db-host = %s", &dbhost);
                        }
                        else if  (strstr (buffer, "db-user")) {
                            sscanf(buffer ,"db-user = %s", &dbuser);
                        }
                        else if  (strstr (buffer, "db-password")) {
                            sscanf(buffer ,"db-password = %s", &dbpassword);
                        }
                        else if  (strstr (buffer, "database")) {
                            sscanf(buffer ,"database = %s", &database);
                        }

                }
                fclose(inputfile);
        }
        else
                printf("Error opening config file.\n");
}


void getdbset()
{

    char *querysetings;
    querysetings = "SELECT * FROM setings WHERE setings = 'setings'";

    mysql_init(&mysql);
        if (!mysql_real_connect(&mysql,dbhost,dbuser,dbpassword,database,0,NULL,0))
        {
        fprintf(stderr, "Failed to connect to database: Error: %s\n",
        mysql_error(&mysql));
        }
			    
    if (mysql_query(&mysql, querysetings))
    exiterr(3);

    if (!(res = mysql_store_result(&mysql)))
    exiterr(4);
			
    while((row = mysql_fetch_row(res))) {

    rdate = (row[1]);
    fdate = (row[2]);	
    intup = (row[3]);
    intdown = (row[4]);
    uprate =(row[5]);
    downrate =(row[6]);
    

     }
							      
    if (!mysql_eof(res))
    exiterr(5);
  
    mysql_free_result(res);
    mysql_close(&mysql);
    
    sprintf(devup,"%s",intup);
    sprintf(devdown,"%s",intdown);
    sprintf(uprootclass,"%s",uprate);
    sprintf(downrootclass,"%s",downrate);
    

}

void updatedbd ()
{

int sent;
int pkts;
int dropped;
int overlimits;
int requeues;
int classid;
int parentid;
int io;
char *spopen;

    char query[1024];
    struct sclass {
        int csent;
        int cpkts;
        int cdropped;
        int coverlimits;
        int crequeues;
        int cclassid;
        int cparentid;

        struct sclass *next;
         } start, *c;

    sprintf(spopen, "tc -s class show dev %s",devdown);
        FILE* cmdp =  popen(spopen, "r");

            if (!cmdp) {
            perror("popen");
            return 1;
                }

            char result[256];

    start.next=NULL;
    c=&start;

while (fgets(result, sizeof(result), cmdp))
    if (strstr (result, "class")) {
    classid=NULL;
    sscanf(result ,"class htb 1:%d parent 1:%d \n", &classid , &parentid);
    }
    else if  (strstr (result, "Sent")) {
    sscanf(result ," Sent %d bytes %d pkts (dropped %d, overlimits %d requeues %d)\n", &sent , &pkts, &dropped, &overlimits, &requeues);
     c->next = (struct sclass *)
         malloc(sizeof(struct sclass));
         c=c->next;
         c->csent = sent;
         c->cpkts = pkts;
         c->cdropped = dropped;
         c->coverlimits = overlimits;
         c->crequeues = requeues;
         c->cclassid = classid;
         c->cparentid = parentid;
         c->next=NULL;
	}
        pclose(cmdp);                // close the stream
        c = start.next;

    mysql_init(&mysql);
    if (!mysql_real_connect(&mysql,dbhost,dbuser,dbpassword,database,0,NULL,0))
    {
    fprintf(stderr, "Failed to connect to database: Error: %s\n",
    mysql_error(&mysql));
    }

    while(c)
        {
    io = c->cclassid ;
        
    sprintf(query, "UPDATE trafic SET d_bytes= '%d',  d_pkts= '%d' WHERE id_qt= '%d' and r_date= '%s'",c->csent,c->cpkts,c->cclassid,rdate);
    if (mysql_query(&mysql, query))
                exiterr(3);
    c=c->next;
        }
        mysql_close(&mysql);
}



void updatedbu ()
{

int sent;
int pkts;
int dropped;
int overlimits;
int requeues;
int classid;
int parentid;
int io;
char *spopen;

    char query[1024];
    struct sclass {
        int csent;
        int cpkts;
        int cdropped;
        int coverlimits;
        int crequeues;
        int cclassid;
        int cparentid;

        struct sclass *next;
         } start, *c;

    sprintf(spopen, "tc -s class show dev %s",devup);
//	printf ("spopen: %s\n",spopen);
        FILE* cmdp =  popen(spopen, "r");

            if (!cmdp) {
            perror("popen");
            return 1;
                }

            char result[256];

    start.next=NULL;
    c=&start;

while (fgets(result, sizeof(result), cmdp))
    if (strstr (result, "class")) {
    classid=NULL;
    sscanf(result ,"class htb 1:%d parent 1:%d \n", &classid , &parentid);
    }
    else if  (strstr (result, "Sent")) {
    sscanf(result ," Sent %d bytes %d pkts (dropped %d, overlimits %d requeues %d)\n", &sent , &pkts, &dropped, &overlimits, &requeues);
     c->next = (struct sclass *)
         malloc(sizeof(struct sclass));
         c=c->next;
         c->csent = sent;
         c->cpkts = pkts;
         c->cdropped = dropped;
         c->coverlimits = overlimits;
         c->crequeues = requeues;
         c->cclassid = classid;
         c->cparentid = parentid;
         c->next=NULL;
	}
        pclose(cmdp);                // close the stream
        c = start.next;

    mysql_init(&mysql);
    if (!mysql_real_connect(&mysql,dbhost,dbuser,dbpassword,database,0,NULL,0))
    {
    fprintf(stderr, "Failed to connect to database: Error: %s\n",
    mysql_error(&mysql));
    }

    while(c)
        {
    io = c->cclassid ;
        
    sprintf(query, "UPDATE trafic SET u_bytes= '%d',  u_pkts= '%d' WHERE id_qt= '%d' and r_date= '%s'",c->csent,c->cpkts,c->cclassid,rdate);
    if (mysql_query(&mysql, query))
                exiterr(3);
    c=c->next;
        }
    sprintf(query, "INSERT into logs(data,log) VALUES ('%s' , '%s')",mylogtime,"New trafic logs for rrd");
    if (mysql_query(&mysql, query))
                exiterr(3);

        mysql_close(&mysql);
}



void getclients()

{

    char *queryclients;
    queryclients = "SELECT * FROM clients";

    mysql_init(&mysql);
        if (!mysql_real_connect(&mysql,dbhost,dbuser,dbpassword,database,0,NULL,0))
        {
        fprintf(stderr, "Failed to connect to database: Error: %s\n",
        mysql_error(&mysql));
        }
			    
    if (mysql_query(&mysql, queryclients))
    exiterr(3);

    if (!(res = mysql_store_result(&mysql)))
    exiterr(4);

     qstart.qnext=NULL;
             q=&qstart;
	     			
    while((row = mysql_fetch_row(res))) {
	
	 q->qnext = (struct qclients *)
         malloc(sizeof(struct qclients));
         q=q->qnext;
         q->qid = row[0];
	 q->qname = row[1];
         q->qip = row[2];
         q->qcir = row[3];
         q->qmir = row[4];
         q->qnext=NULL;

     }
    q = qstart.qnext;							      
    if (!mysql_eof(res))
    exiterr(5);
  
    mysql_free_result(res);
    mysql_close(&mysql);
    
				 

}

void sethtbd()
{
    getclients();
    
    char delqdisc[256];
    char newqdisc[256];
    char rclass[256];
    char dclass[256];
    char dqdisc[256];
    char aclass[256];
    
    char clntclass[512];
    char clntfilter[512];
    char clntqdisc[512];
    
    sprintf(delqdisc,"tc qdisc del dev %s root >/dev/null",devdown);
    sprintf(newqdisc,"tc qdisc add dev %s root handle 1: htb default 10 >/dev/null",devdown);
    sprintf(rclass,"tc class add dev %s parent 1: classid 1:1 htb rate %skbit ceil %skbit burst 2k",devdown,downrootclass,downrootclass);
    
    sprintf(dclass,"tc class add dev %s parent 1:1 classid 1:10 htb rate 8kbit ceil 8kbit burst 2k",devdown);
    sprintf(dqdisc,"tc qdisc add dev %s parent 1:10 handle 10: pfifo limit 5",devdown);
    
    sprintf(aclass,"tc class add dev %s parent 1:1 classid 1:0x20 htb rate %skbit ceil %skbit burst 2k prio 1",devdown,downrootclass,downrootclass);
/*    
    printf("%s\n",delqdisc);
    printf("%s\n",newqdisc);
    printf("%s\n",rclass);
    printf("%s\n",dclass);
    printf("%s\n",dqdisc);
    printf("%s\n",aclass);
*/


    
    system(delqdisc);
    system(newqdisc);
    system(rclass);
    system(dclass);
    system(dqdisc);
    system(aclass);
    
    
    	    
 while(q)
        {
	
	sprintf(clntclass,"tc class add dev %s parent 1:20 classid 1:2%s htb rate %skbit ceil %skbit burst 2k prio 1 quantum 1500",devdown,q->qid,q->qcir,q->qmir);
	sprintf(clntfilter,"tc filter add dev %s protocol ip parent 1:0 prio 1 u32 match ip dst %s flowid 1:2%s",devdown,q->qip,q->qid);
	sprintf(clntqdisc,"tc qdisc add dev %s parent 1:2%s handle 2%s: pfifo limit 5",devdown,q->qid,q->qid);
		 
	
	
	 system(clntclass);
	 system(clntfilter);
	 system(clntqdisc);

	q=q->qnext;
	}

    sethtbu();
}



void sethtbu()
{
    getclients();
    char udelqdisc[256];
    char unewqdisc[256];
    char urclass[256];
    char udclass[256];
    char udqdisc[256];
    char uaclass[256];
    
    char uclntclass[512];
    char uclntfilter[512];
    char uclntqdisc[512];
    
    sprintf(udelqdisc,"tc qdisc del dev %s root >/dev/null",devup);
    sprintf(unewqdisc,"tc qdisc add dev %s root handle 1: htb default 10 >/dev/null",devup);
    sprintf(urclass,"tc class add dev %s parent 1: classid 1:1 htb rate %skbit ceil %skbit burst 2k",devup,uprootclass,uprootclass);
    
    sprintf(udclass,"tc class add dev %s parent 1:1 classid 1:10 htb rate 8kbit ceil 8kbit burst 2k",devup);
    sprintf(udqdisc,"tc qdisc add dev %s parent 1:10 handle 10: pfifo limit 5",devup);
    
    sprintf(uaclass,"tc class add dev %s parent 1:1 classid 1:0x20 htb rate %skbit ceil %skbit burst 2k prio 1",devup,uprootclass,uprootclass);
    system(udelqdisc);
    system(unewqdisc);
    system(urclass);
    system(udclass);
    system(udqdisc);
    system(uaclass);
    
    
    	    
 while(q)
        {
	
	sprintf(uclntclass,"tc class add dev %s parent 1:20 classid 1:2%s htb rate %skbit ceil %skbit burst 2k prio 1 quantum 1500",devup,q->qid,q->qcir,q->qmir);
	sprintf(uclntfilter,"tc filter add dev %s protocol ip parent 1:0 prio 1 u32 match ip src %s flowid 1:2%s",devup,q->qip,q->qid);
	sprintf(uclntqdisc,"tc qdisc add dev %s parent 1:2%s handle 2%s: pfifo limit 5",devup,q->qid,q->qid);
	 system(uclntclass);
	 system(uclntfilter);
	 system(uclntqdisc);
	q=q->qnext;
	}

insertraf();
}




void checkserial()
{


int kakt;
    kakt = (strcmp (rdate, fdate)
    );
    
    if (kakt != 0)
          {
	  
	sethtbd();
	
	  
	  }
    else
    {
    
    }

     
}



void insertraf()
{
    

//    printf("mytime: %s\n",mytime);
		    
    char queryupdatetime[256];
    mysql_init(&mysql);
    if (!mysql_real_connect(&mysql,dbhost,dbuser,dbpassword,database,0,NULL,0))
    {
    fprintf(stderr, "Failed to connect to database: Error: %s\n",
    mysql_error(&mysql));
    }


    sprintf(queryupdatetime, "UPDATE setings SET r_date = '%s',  f_date= '%s' WHERE setings= 'setings'",mytime,mytime);
    if (mysql_query(&mysql, queryupdatetime))
                exiterr(3);
    
    mysql_close(&mysql);

    getclients();
    char queryinserttrafic[256];
    char cid[15];
    mysql_init(&mysql);
    if (!mysql_real_connect(&mysql,dbhost,dbuser,dbpassword,database,0,NULL,0))
    {
    fprintf(stderr, "Failed to connect to database: Error: %s\n",
    mysql_error(&mysql));
    }
    
    sprintf(queryinserttrafic, "INSERT into trafic(id_qt, r_date, id_num, mir) VALUES ('%s' , '%s', '%s','%s')","1",mytime,"ROOT_CLASS",downrootclass);
    if (mysql_query(&mysql, queryinserttrafic))
                exiterr(3);
    
    sprintf(queryinserttrafic, "INSERT into trafic(id_qt, r_date, id_num, mir) VALUES ('%s' , '%s', '%s','%s')","10",mytime,"DEFAULT_CLASS","8");
    if (mysql_query(&mysql, queryinserttrafic))
                exiterr(3);
    
    sprintf(queryinserttrafic, "INSERT into trafic(id_qt, r_date, id_num, mir) VALUES ('%s' , '%s', '%s','%s')","20",mytime,"MYCLASS",downrootclass);
    if (mysql_query(&mysql, queryinserttrafic))
                exiterr(3);
    
    

     while(q)
             {
	    sprintf(cid,"2%s",q->qid);
	    sprintf(queryinserttrafic, "INSERT into trafic(id_qt, r_date, id_num, mir) VALUES ('%s' , '%s', '%s','%s')",cid,mytime,q->qname,q->qmir);
	    if (mysql_query(&mysql, queryinserttrafic))
            exiterr(3);
            q=q->qnext;
	    }
	
    sprintf(queryinserttrafic, "INSERT into logs(data,log) VALUES ('%s' , '%s')",mylogtime,"New computing QOS");
    if (mysql_query(&mysql, queryinserttrafic))
                exiterr(3);
	       
    
    mysql_close(&mysql);


}

