/*
*       myrrd.c        Silviu Vladuti   <zyx@zyx.ro>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include "mysql.h"
#include <time.h>

char dbhost[256];
char dbuser[256];
char dbpassword[256];
char database[256];

 
char *devup, *devdown;
char *uprootclass , *downrootclass;
char *rdate , *fdate;
char *outputrrd;
char outputd[256];
char mytime[25];

char katk[256];

struct tm *data_curenta;
time_t  secunde;
		
MYSQL mysql;
MYSQL_RES *res;
MYSQL_ROW row;

struct rclients {
    char *tid;
    char *tname;
    char *ubytes;
    char *dbytes;
    char *tmir;

    struct rclients *rnext;
    } rstart, *r;



		    
int exiterr(int exitcode)
{
    fprintf( stderr, "%s\n", mysql_error(&mysql) );
    exit( exitcode );
}
	

int main() {
    
    time(&secunde);
    data_curenta = localtime(&secunde);

    sprintf(mytime,"%d%d%d%d%d",data_curenta->tm_mon+1,data_curenta->tm_mday,data_curenta->tm_year+1900,data_curenta->tm_hour,data_curenta->tm_min);		   
	printf("%s\n",mytime);	   

    getconf();


    getdbset();
    putinrrd();
    rrdcheck();

return 0;					
}

int getconf()
{
        char buffer[100];       // a variable for the strings we read in
        FILE *inputfile;        // a pointer to the input file
        inputfile = fopen("/etc/myhtb.conf", "r");      // open myhtb.conf
        if(inputfile != NULL)
        {
                while (fgets(buffer, 100, inputfile))
                {
                        if (strstr (buffer, "db-host")) {
                        sscanf(buffer ,"db-host = %s", &dbhost);
                        }
                        else if  (strstr (buffer, "db-user")) {
                            sscanf(buffer ,"db-user = %s", &dbuser);
                        }
                        else if  (strstr (buffer, "db-password")) {
                            sscanf(buffer ,"db-password = %s", &dbpassword);
                        }
                        else if  (strstr (buffer, "database")) {
                            sscanf(buffer ,"database = %s", &database);
                        }

                }
                fclose(inputfile);
        }
        else
                printf("Error opening config file.\n");
}


void getdbset()
{

    char *query, *querysetings;
    querysetings = "SELECT * FROM setings WHERE setings = 'setings'";

    mysql_init(&mysql);
        if (!mysql_real_connect(&mysql,dbhost,dbuser,dbpassword,database,0,NULL,0))
        {
        fprintf(stderr, "Failed to connect to database: Error: %s\n",
        mysql_error(&mysql));
        }
			    
    if (mysql_query(&mysql, querysetings))
    exiterr(3);

    if (!(res = mysql_store_result(&mysql)))
    exiterr(4);
			
    while((row = mysql_fetch_row(res))) {

    rdate = (row[1]);
    fdate = (row[2]);	
    devup = (row[3]);
    devdown = (row[4]);
    uprootclass =(row[5]);
    downrootclass =(row[6]);
    outputrrd=(row[7]);

     }
							      
    if (!mysql_eof(res))
    exiterr(5);
  
    mysql_free_result(res);
    mysql_close(&mysql);
    
    sprintf(outputd,"%s",outputrrd);

}


void getclients()
{


    char queryrrd[256];
    sprintf (queryrrd, "SELECT * FROM trafic WHERE r_date = '%s'",rdate);
    mysql_init(&mysql);
        if (!mysql_real_connect(&mysql,dbhost,dbuser,dbpassword,database,0,NULL,0))
        {
        fprintf(stderr, "Failed to connect to database: Error: %s\n",
        mysql_error(&mysql));
        }
			    
    if (mysql_query(&mysql, queryrrd))
    exiterr(3);

    if (!(res = mysql_store_result(&mysql)))
    exiterr(4);

     rstart.rnext=NULL;
             r=&rstart;
	     			
    while((row = mysql_fetch_row(res))) {

    
    
	 r->rnext = (struct rclients *)
         malloc(sizeof(struct rclients));
         r=r->rnext;
         r->tid = row[0];
	 r->tname = row[2];
         r->ubytes = row[3];
         r->dbytes = row[4];
         r->tmir = row[7];
         r->rnext=NULL;

     }
    r = rstart.rnext;							      
    if (!mysql_eof(res))
    exiterr(5);
  
    mysql_free_result(res);
    mysql_close(&mysql);
    
				 

}

void putinrrd()
{
    getclients();
    char popenrrd[256];
	    
while(r)
        {
	
long val_long;
	   val_long =atol(r->tmir);
	val_long=val_long/8*1024;
	
	sprintf(popenrrd,"rrdupdate %s%s.rrd N:%s:%s:%ld",outputd,r->tid,r->ubytes,r->dbytes,val_long);

	 system(popenrrd);
	r=r->rnext;
	}

}



void rrdcheck()
{
    getclients();
    char createrrd[1256];
    char rrdfile[256];	    
while(r)
        {
	
    FILE *inputfile;        // a pointer to the input file
	sprintf (rrdfile,"%s%s.rrd",outputd,r->tid);
        sprintf (createrrd,"rrdtool create %s%s.rrd -s 300 DS:Upload:DERIVE:600:0:1000000 DS:Download:DERIVE:600:0:1000000 DS:Mir:GAUGE:600:0:1000000 RRA:AVERAGE:0.5:1:576 RRA:AVERAGE:0.5:6:672 RRA:AVERAGE:0.5:24:732 RRA:AVERAGE:0.5:144:1460",outputd,r->tid);
	inputfile = fopen(rrdfile, "r");     
        if(inputfile != NULL)
	        {
		fclose(inputfile);
	        }
	        else{
                printf("Error opening rrd file = %s\n",rrdfile);
		system(createrrd);
		}							

	r=r->rnext;
	}
}



